package bugs.toplink.serializable;

import java.io.Serializable;
import java.util.HashMap;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.PostUpdate;
import javax.persistence.Transient;

@Entity
public class Employee {
	
	@Id
	@GeneratedValue
	private Long id;
	
	private HashMap<String, Serializable> properties = new HashMap<String, Serializable>();
	
	@Transient
	private static Runnable updateListener;
	
	public Employee() { }
	
	public Long getId() {
		return id;
	}
	
	public void putProperty(String key, Serializable s) {
		properties.put(key, s);
	}
	
	public Serializable getProperty(String key) {
		return properties.get(key);
	}
	
	public static void setListener(Runnable listener) {
		updateListener = listener;
	}
	
	@PostUpdate
	public void postUpdate() {
		if (updateListener != null) {
			updateListener.run();
		}
	}

	public HashMap<String, Serializable> getProperties() {
		return properties;
	}
}
